/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WebMail Notifier.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const Ci=Components.interfaces;
const dout=Components.utils.reportError;

var script={
  onLoad:function(){
    this.wmn = Components.classes["@mozilla.org/WebMailNotifier;1"]
                .getService(Ci.nsIWebMailNotifier);
    this.main=window.arguments[0];
    this.list=[];
    var ar=this.wmn.getScriptList();
    var e = ar.enumerate();
    while(e.hasMoreElements())
    {
      var file = e.getNext().QueryInterface(Ci.nsIFile);
      var obj=new Object();
      obj.file=file;
      obj.fname=this.getFileName(file);
      this.list.push(obj);
    }
    this.list.sort(this.sortFunc);
    for each(var o in this.list)this.addItem(o);
  },
  remove:function(ar,obj){
    for(var i in ar){
      if(ar[i]==obj){
        ar.splice(i,1);
        return true;
      }
    }
    return false;
  },
  onAdd:function(){
    var fp = Components.classes["@mozilla.org/filepicker;1"]
    	           .createInstance(Ci.nsIFilePicker);
    fp.init(window, "Open",Ci.nsIFilePicker.modeOpen);
    fp.appendFilter ("Javascript","*.js");
    fp.appendFilters(Ci.nsIFilePicker.filterAll);

    var rv = fp.show();
    if (rv == Ci.nsIFilePicker.returnOK)
    {
      var file = fp.file;
      var obj=new Object();
      obj.file=file;
      obj.fname=this.getFileName(file);
      for each(var o in this.list){
        if(o.fname==obj.fname)return;
      }
      this.list.push(obj);
      this.addItem(obj);

      var str=this.wmn.loadFile(obj.file);
      var fnd=str.match(/function\s+initHandler\s*\(/);
      var n=-1;
      if(fnd){
        n=this.wmn.getAvailableID();
        str=str.replace(/(function\s+)(initHandler)(\s*\()/,"$1$2"+n+"$3");
      }
      obj.file=this.wmn.saveFile("wmn/"+obj.fname,str);
      this.wmn.loadScript(obj.fname,n);
      if(n>=0)this.main.addHost(n);
    }
  },
  onDelete:function(){
    var obj=document.getElementById("wmn-scripts");
    var index=obj.selectedIndex;
    if(index<0)return;
    var o=this.list[index];
    this.list.splice(index,1);
    obj.removeItemAt(index);

    var str=this.wmn.loadFile(o.file);
    var fnd=str.match(/function\s+initHandler(\d+)\s*\(/);
    var n=-1;
    if(fnd){
      n=fnd[1];
      this.wmn.removeHost(n);
    }
    o.file.remove(false);
    if(n>=0)this.main.removeHost(n);
  },
  addItem:function(obj){
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Ci.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
                         .QueryInterface(Ci.nsIFileProtocolHandler);
    var em = document.createElement("listitem");
      var ch = document.createElement("listcell");
      ch.setAttribute("label",obj.fname);
      em.appendChild(ch);
    document.getElementById("wmn-scripts").appendChild(em);
  },
  getFileName:function(file){
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Ci.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
                         .QueryInterface(Ci.nsIFileProtocolHandler);
    var fname=fileHandler.getURLSpecFromFile(file);
    fname=fname.match(/\/([^\/]+)$/);
    return fname[1];
  },
  sortFunc:function(a,b) {
    if(a.fname<b.fname)return -1;
    else if(a.fname==b.fname){
      return 0;
    }else return 1;
  }
}